Index: branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1016)
+++ branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1017)
@@ -764,8 +764,10 @@
   ("LimQtPredFlag",                   m_bLimQtPredFlag          , true          , "Use Predictive Coding with QTL" )
 #endif
-#if !MTK_I0099_VPS_EX2
+#if !MTK_I0099_VPS_EX2 || MTK_I0099_FIX
 #if H_3D_QTLPC
   ("QTL",                             m_bUseQTL                 , true          , "Use depth Quadtree Limitation" )
+#if !MTK_I0099_VPS_EX2
   ("PC",                              m_bUsePC                  , true          , "Use Predictive Coding with QTL" )
+#endif
 #endif
 #endif
@@ -2497,10 +2499,12 @@
 #endif
 #if MTK_I0099_VPS_EX2
-  printf("LimQtPredFlag:%d", m_bLimQtPredFlag ? 1 : 0);
-#endif
-#if !MTK_I0099_VPS_EX2
+  printf("LimQtPredFlag:%d ", m_bLimQtPredFlag ? 1 : 0);
+#endif
+#if !MTK_I0099_VPS_EX2 || MTK_I0099_FIX
 #if H_3D_QTLPC
   printf("QTL:%d ", m_bUseQTL);
+#if !MTK_I0099_VPS_EX2
   printf("PC:%d " , m_bUsePC );
+#endif
 #endif
 #endif
Index: branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncCfg.h	(revision 1016)
+++ branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncCfg.h	(revision 1017)
@@ -476,8 +476,10 @@
   Bool      m_useDLT;                                        ///< flag for using DLT
 #endif
-#if !MTK_I0099_VPS_EX2
+#if !MTK_I0099_VPS_EX2 || MTK_I0099_FIX
 #if H_3D_QTLPC
   Bool      m_bUseQTL;                                        ///< flag for using depth QuadTree Limitation
+#if !MTK_I0099_VPS_EX2
   Bool      m_bUsePC;                                         ///< flag for using Predictive Coding with QTL
+#endif
 #endif
 #endif
Index: branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1016)
+++ branches/HTM-11.2-dev2-MediaTek/source/App/TAppEncoder/TAppEncTop.cpp	(revision 1017)
@@ -202,8 +202,10 @@
     m_cTEncTop.setUseDLT                       ( isDepth ? m_useDLT               : false );
 #endif
-#if !MTK_I0099_VPS_EX2
+#if !MTK_I0099_VPS_EX2 || MTK_I0099_FIX
 #if H_3D_QTLPC
     m_cTEncTop.setUseQTL                       ( isDepth ? m_bUseQTL               : false );
+#if !MTK_I0099_VPS_EX2    
     m_cTEncTop.setUsePC                        ( isDepth ? m_bUsePC                : false );
+#endif
 #endif
 #endif
Index: branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibCommon/TypeDef.h	(revision 1016)
+++ branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibCommon/TypeDef.h	(revision 1017)
@@ -251,5 +251,5 @@
 
 #define MTK_I0099_VPS_EX2                 1  ///< JCT3V-I0099, sub-PU size signaling and lim_qt_pred_flag in VPS extension 2
-
+#define MTK_I0099_FIX                     1  ///< Fix the problem of removing encoder only QTL 
 
 // Rate Control
Index: branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncCfg.h	(revision 1016)
+++ branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncCfg.h	(revision 1017)
@@ -420,8 +420,10 @@
   Bool      m_useMPI;
 #endif
-#if !MTK_I0099_VPS_EX2
+#if !MTK_I0099_VPS_EX2 || MTK_I0099_FIX
 #if H_3D_QTLPC
   Bool      m_bUseQTL;
+#if !MTK_I0099_VPS_EX2
   Bool      m_bUsePC;
+#endif
 #endif
 #endif
@@ -1010,10 +1012,12 @@
   Void      setUseDLT                       ( Bool b) { m_useDLT = b;    }
 #endif
-#if !MTK_I0099_VPS_EX2
+#if !MTK_I0099_VPS_EX2 || MTK_I0099_FIX
 #if H_3D_QTLPC
   Void      setUseQTL                       ( Bool b ) { m_bUseQTL = b;    }
   Bool      getUseQTL                       ()         { return m_bUseQTL; }
+#if !MTK_I0099_VPS_EX2
   Void      setUsePC                        ( Bool b ) { m_bUsePC  = b;    }
   Bool      getUsePC                        ()         { return m_bUsePC;  }
+#endif
 #endif
 #endif
Index: branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1016)
+++ branches/HTM-11.2-dev2-MediaTek/source/Lib/TLibEncoder/TEncCu.cpp	(revision 1017)
@@ -537,5 +537,9 @@
 
 #if MTK_I0099_VPS_EX2
+#if MTK_I0099_FIX
+      if(depthMapDetect && !bIntraSliceDetect && !rapPic && ( m_pcEncCfg->getUseQTL() || bLimQtPredFalg ))
+#else
       if(depthMapDetect && !bIntraSliceDetect && !rapPic && bLimQtPredFalg)
+#endif
 #else
       if(depthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTL())
@@ -695,5 +699,9 @@
 #if H_3D_QTLPC      
 #if MTK_I0099_VPS_EX2
+#if MTK_I0099_FIX
+      if(depthMapDetect && !bIntraSliceDetect && !rapPic && ( m_pcEncCfg->getUseQTL() || bLimQtPredFalg ))
+#else
       if(depthMapDetect && !bIntraSliceDetect && !rapPic && bLimQtPredFalg)
+#endif
 #else
       if(depthMapDetect && !bIntraSliceDetect && !rapPic && sps->getUseQTL())