Index: branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 968)
+++ branches/SHM-dev/cfg/per-sequence-svc/BQTerrace-2x.cfg	(revision 1032)
@@ -30,6 +30,6 @@
 
 #============= Reference location offset parameters ==================
-NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
-ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+NumRefLocationOffsets1         : 1        # Number of reference location offset parameters
+RefLocationOffsetLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
 ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
 RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 968)
+++ branches/SHM-dev/cfg/per-sequence-svc/BasketballDrive-2x.cfg	(revision 1032)
@@ -30,6 +30,6 @@
 
 #============= Reference location offset parameters ==================
-NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
-ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+NumRefLocationOffsets1         : 1        # Number of reference location offset parameters
+RefLocationOffsetLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
 ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
 RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 968)
+++ branches/SHM-dev/cfg/per-sequence-svc/Cactus-2x.cfg	(revision 1032)
@@ -30,6 +30,6 @@
 
 #============= Reference location offset parameters ==================
-NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
-ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+NumRefLocationOffsets1         : 1        # Number of reference location offset parameters
+RefLocationOffsetLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
 ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
 RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 968)
+++ branches/SHM-dev/cfg/per-sequence-svc/Kimono-2x.cfg	(revision 1032)
@@ -30,6 +30,6 @@
 
 #============= Reference location offset parameters ==================
-NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
-ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+NumRefLocationOffsets1         : 1        # Number of reference location offset parameters
+RefLocationOffsetLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
 ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
 RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags
Index: branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg
===================================================================
--- branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 968)
+++ branches/SHM-dev/cfg/per-sequence-svc/ParkScene-2x.cfg	(revision 1032)
@@ -30,6 +30,6 @@
 
 #============= Reference location offset parameters ==================
-NumScaledRefLayerOffsets1        : 1        # Number of reference location offset parameters
-ScaledRefLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
+NumRefLocationOffsets1         : 1        # Number of reference location offset parameters
+RefLocationOffsetLayerId1                : 0        # List of ref layer id (i-th entry for i-th ref loc offset parameters)
 ScaledRefLayerOffsetPresentFlag1 : 0        # List of scaled ref layer offset present flags
 RefRegionOffsetPresentFlag1      : 1        # List of ref region offset present flags