Index: trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_2view+depth_AllIntra.cfg
===================================================================
--- trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_2view+depth_AllIntra.cfg	(revision 1039)
+++ trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_2view+depth_AllIntra.cfg	(revision 1040)
@@ -177,5 +177,5 @@
 DLT                                : 1
 QTL                                : 1
-PC                                 : 1
+LimQtPredFlag                      : 1
 InterSDC                           : 1                             # use of inter sdc
 MPI                                : 1
Index: trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_3view+depth_AllIntra.cfg
===================================================================
--- trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_3view+depth_AllIntra.cfg	(revision 1039)
+++ trunk/cfg/3D-HEVC/NonCTC/allintra/baseCfg_3view+depth_AllIntra.cfg	(revision 1040)
@@ -192,5 +192,5 @@
 DLT                                : 1
 QTL                                : 1
-PC                                 : 1
+LimQtPredFlag                      : 1
 InterSDC                           : 1                             # use of inter sdc
 MPI                                : 1
Index: trunk/cfg/3D-HEVC/NonCTC/fco/baseCfg_3view+depth.cfg
===================================================================
--- trunk/cfg/3D-HEVC/NonCTC/fco/baseCfg_3view+depth.cfg	(revision 1039)
+++ trunk/cfg/3D-HEVC/NonCTC/fco/baseCfg_3view+depth.cfg	(revision 1040)
@@ -234,10 +234,10 @@
 
 #========== depth coding tools ==========
-VSO                       : 1                                      # use of view synthesis optimization for depth coding
+VSO                                : 1                 # use of view synthesis optimization for depth coding
 DMM                                : 1
 SDC                                : 1
 DLT                                : 1
 QTL                                : 0
-PC                                 : 0
+LimQtPredFlag                      : 0
 InterSDC                           : 1                             # use of inter sdc
 MPI                                : 1
Index: trunk/cfg/3D-HEVC/NonCTC/rc/baseCfg_3view+depth_rate_control.cfg
===================================================================
--- trunk/cfg/3D-HEVC/NonCTC/rc/baseCfg_3view+depth_rate_control.cfg	(revision 1039)
+++ trunk/cfg/3D-HEVC/NonCTC/rc/baseCfg_3view+depth_rate_control.cfg	(revision 1040)
@@ -252,5 +252,5 @@
 DLT                                : 1
 QTL                                : 1
-PC                                 : 1
+LimQtPredFlag                      : 1
 InterSDC                           : 1                             # use of inter sdc
 MPI                                : 1
Index: trunk/cfg/3D-HEVC/baseCfg_2view+depth.cfg
===================================================================
--- trunk/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 1039)
+++ trunk/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 1040)
@@ -213,5 +213,5 @@
 DLT                                : 1
 QTL                                : 1
-PC                                 : 1
+LimQtPredFlag                      : 1
 InterSDC                           : 1                             # use of inter sdc
 MPI                                : 1
Index: trunk/cfg/3D-HEVC/baseCfg_3view+depth.cfg
===================================================================
--- trunk/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 1039)
+++ trunk/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 1040)
@@ -244,5 +244,5 @@
 DLT                                : 1
 QTL                                : 1
-PC                                 : 1
+LimQtPredFlag                      : 1
 InterSDC                           : 1                             # use of inter sdc
 MPI                                : 1
Index: trunk/cfg/3D-HEVC/fullCfg.cfg
===================================================================
--- trunk/cfg/3D-HEVC/fullCfg.cfg	(revision 1039)
+++ trunk/cfg/3D-HEVC/fullCfg.cfg	(revision 1040)
@@ -266,5 +266,5 @@
 DLT                                : 1
 QTL                                : 1
-PC                                 : 1
+LimQtPredFlag                      : 1
 InterSDC                           : 1                             # use of inter sdc
 MPI                                : 1