Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1043)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 1044)
@@ -195,5 +195,5 @@
     // Decoded layer YUV files
 #if FIX_CONF_MODE
-    for(Int layer= 0; layer < MAX_VPS_LAYER_ID_PLUS1; layer++ )
+    for(Int layer= 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++ )
 #else
     for(UInt layer=0; layer<= m_tgtLayerId; layer++)
@@ -210,5 +210,5 @@
 #endif
 #if FIX_CONF_MODE
-  for(Int layer = 0; layer < MAX_VPS_LAYER_ID_PLUS1; layer++ )
+  for(Int layer = 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++ )
   {
 #else
Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1043)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.cpp	(revision 1044)
@@ -89,5 +89,5 @@
 #if SVC_EXTENSION
 #if FIX_CONF_MODE
-  for(Int i = 0; i < MAX_VPS_LAYER_ID_PLUS1; i++ )
+  for(Int i = 0; i < MAX_VPS_LAYER_IDX_PLUS1; i++ )
 #else
   for( Int i = 0; i <= m_tgtLayerId; i++ )
@@ -163,5 +163,5 @@
 
 #if FIX_CONF_MODE
-  for(UInt layer = 0; layer < MAX_VPS_LAYER_ID_PLUS1; layer++)
+  for(UInt layer = 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++)
 #else
   for(UInt layer=0; layer<=m_tgtLayerId; layer++)
@@ -406,5 +406,5 @@
 
 #if FIX_CONF_MODE
-  for(UInt layer = layerIdmin; layer < MAX_VPS_LAYER_ID_PLUS1; layer++)
+  for(UInt layer = layerIdmin; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++)
 #else
   for(UInt layer = layerIdmin; layer <= m_tgtLayerId; layer++)
@@ -595,5 +595,5 @@
 
 #if FIX_CONF_MODE
-  for(UInt layer = 0; layer < MAX_VPS_LAYER_ID_PLUS1; layer++)
+  for(UInt layer = 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++)
 #else
   for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
@@ -621,5 +621,5 @@
 
 #if FIX_CONF_MODE
-  for(UInt layer = 0; layer < MAX_VPS_LAYER_ID_PLUS1; layer++)
+  for(UInt layer = 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++)
 #else
   for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
@@ -650,5 +650,5 @@
 #if SVC_EXTENSION
 #if FIX_CONF_MODE
-  for(UInt layer = 0; layer < MAX_VPS_LAYER_ID_PLUS1; layer++)
+  for(UInt layer = 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++)
 #else
   for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
@@ -671,5 +671,5 @@
 #if CONFORMANCE_BITSTREAM_MODE
 #if FIX_CONF_MODE
-  for(UInt layer = 0; layer < MAX_VPS_LAYER_ID_PLUS1; layer++)
+  for(UInt layer = 0; layer < MAX_VPS_LAYER_IDX_PLUS1; layer++)
 #else
   for(UInt layer = 0; layer < MAX_LAYERS; layer++)
@@ -1282,6 +1282,6 @@
     std::vector<Int>  listOfPocs;
 #if FIX_ALIGN_BUMPING
-    std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
-    std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
+    std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
+    std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
 #else
     std::vector<Int>  listOfPocsInEachLayer[MAX_LAYERS];
@@ -1314,6 +1314,6 @@
     std::vector<Int>  listOfPocs;
 #if FIX_ALIGN_BUMPING
-    std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
-    std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
+    std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
+    std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
 #else
     std::vector<Int>  listOfPocsInEachLayer[MAX_LAYERS];
@@ -1342,5 +1342,5 @@
 {
 #if FIX_ALIGN_BUMPING
-  for(Int i = 0; i < MAX_VPS_LAYER_ID_PLUS1; i++)
+  for(Int i = 0; i < MAX_VPS_LAYER_IDX_PLUS1; i++)
 #else
   for(Int i = 0; i < MAX_LAYERS; i++)
@@ -1385,6 +1385,6 @@
   std::vector<Int>  listOfPocs;
 #if FIX_ALIGN_BUMPING
-  std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
-  std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
+  std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
+  std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
 #else
   std::vector<Int>  listOfPocsInEachLayer[MAX_LAYERS];
@@ -1442,6 +1442,6 @@
   std::vector<Int>  listOfPocs;
 #if FIX_ALIGN_BUMPING
-  std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
-  std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
+  std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
+  std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
 #else
   std::vector<Int>  listOfPocsInEachLayer[MAX_LAYERS];
@@ -1633,5 +1633,5 @@
     // -------------------------------------
 #if FIX_ALIGN_BUMPING
-    for(Int i = 0; i < MAX_VPS_LAYER_ID_PLUS1; i++)
+    for(Int i = 0; i < MAX_VPS_LAYER_IDX_PLUS1; i++)
 #else
     for(Int i = 0; i < MAX_LAYERS; i++)
@@ -1685,5 +1685,5 @@
 {
 #if FIX_ALIGN_BUMPING
-  for(Int layerIdx = 0; layerIdx < MAX_VPS_LAYER_ID_PLUS1; layerIdx++)
+  for(Int layerIdx = 0; layerIdx < MAX_VPS_LAYER_IDX_PLUS1; layerIdx++)
 #else
   for(Int layerIdx = 0; layerIdx < MAX_LAYERS; layerIdx++)
@@ -1744,5 +1744,5 @@
   dpbStatus.init();
 #if FIX_ALIGN_BUMPING
-  for( Int i = 0; i < MAX_VPS_LAYER_ID_PLUS1; i++ )
+  for( Int i = 0; i < MAX_VPS_LAYER_IDX_PLUS1; i++ )
 #else
   for( Int i = 0; i < MAX_LAYERS; i++ )
@@ -1818,5 +1818,5 @@
 
 #if FIX_ALIGN_BUMPING
-  for(Int i = 0; i < MAX_VPS_LAYER_ID_PLUS1; i++)
+  for(Int i = 0; i < MAX_VPS_LAYER_IDX_PLUS1; i++)
 #else
   for(Int i = 0; i < dpbStatus.m_numLayers; i++)
@@ -1838,6 +1838,6 @@
     std::vector<Int>  listOfPocs;
 #if FIX_ALIGN_BUMPING
-    std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
-    std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_ID_PLUS1];
+    std::vector<Int>  listOfPocsInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
+    std::vector<Int>  listOfPocsPositionInEachLayer[MAX_VPS_LAYER_IDX_PLUS1];
 #else
     std::vector<Int>  listOfPocsInEachLayer[MAX_LAYERS];
Index: /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1043)
+++ /branches/SHM-dev/source/App/TAppDecoder/TAppDecTop.h	(revision 1044)
@@ -144,5 +144,5 @@
   Int m_numPicsInSubDpb[MAX_LAYERS];  // Pictures marked as used_for_reference or needed for output in the sub-DPB
 #if FIX_ALIGN_BUMPING
-  Int m_layerIdToSubDpbIdMap[MAX_VPS_LAYER_ID_PLUS1];
+  Int m_layerIdToSubDpbIdMap[MAX_VPS_LAYER_IDX_PLUS1];
   Int m_targetDecLayerIdList[MAX_LAYERS];
 #endif
@@ -171,5 +171,5 @@
 #if FIX_ALIGN_BUMPING
     ::memset( m_targetDecLayerIdList, 0, sizeof(m_targetDecLayerIdList) );
-    for(Int i = 0; i < MAX_VPS_LAYER_ID_PLUS1; i++)
+    for(Int i = 0; i < MAX_VPS_LAYER_IDX_PLUS1; i++)
     {
       m_layerIdToSubDpbIdMap[i] = -1;